import processing.serial.*;
import java.util.* ;

// code written by Mitko Nikov

ArrayList<TEXTBOX> textboxes = new ArrayList<TEXTBOX>();
ArrayList<BUTTON> buttons = new ArrayList<BUTTON>();



   BUTTON button1 = new BUTTON(410, 103, 200, 35, "sine");
   BUTTON button2 = new BUTTON(410, 153, 200, 35, "rect");
   BUTTON button3 = new BUTTON(410, 203, 200, 35, "triangle");
   BUTTON button4 = new BUTTON(410, 253, 200, 35, "test");
   
TEXTBOX userTB ;

void setup() {
   size(700, 350);
   
   // USERNAME TEXTBOX
   // CONFIGURED USING THE GLOBAL VARS
   userTB = new TEXTBOX();
   userTB.X = 160;
   userTB.Y = 103;
   userTB.W = 200;
   userTB.H = 35;
   userTB.addText('1') ;
   userTB.addText('.') ;
   userTB.addText('5') ;
   userTB.addText('M') ; 
   // PASSWORD TEXTBOX
   // CONFIGURED USING THE CLASS CONSTRACTOR
  // TEXTBOX passTB = new TEXTBOX(160, 153, 200, 35);
   
  // passTB.BorderWeight = 3;
  // passTB.BorderEnable = true;
   
   textboxes.add(userTB);
 //  textboxes.add(passTB);
   
 
   buttons.add(button1) ;
   buttons.add(button2) ;
   buttons.add(button3) ;
   buttons.add(button4) ; 
   
   RS232setup() ; 
}

void draw() {
   background(40, 160, 40);
   
   // LABELS
   fill(250, 250, 250);
   text("DDS-CONTROL", (width - textWidth("DDS-CONTROL")) / 2, 60);
   textSize(15);
   // text("Press Enter to Login", (width - textWidth("Press Enter to Login")) / 2, 80);
   textSize(24);
   text("Frequency: ", 20, 130);
  // text("Password: ", 20, 180);
   
   // DRAW THE TEXTBOXES
   for (TEXTBOX t : textboxes) {
      t.DRAW();
   }
   for (BUTTON t : buttons) {
      t.DRAW();
   }
 }

void mousePressed() {
   for (TEXTBOX t : textboxes) { t.PRESSED(mouseX, mouseY); }
   for (BUTTON t : buttons) { t.PRESSED(mouseX, mouseY); }
   
 
   
   if (button1.overBox(mouseX, mouseY)) {
     println("button1 pressed") ; 
     doButton1() ; }
   if (button2.overBox(mouseX, mouseY)) {
     println("button2 pressed") ;
     doButton2() ;
     }
   if (button3.overBox(mouseX, mouseY)) {
     println("button3 pressed") ;
     doButton3() ;
     }
   if (button4.overBox(mouseX, mouseY)) {
     println("button4 pressed") ;
     doButton4() ;
     }       
     
}



void keyPressed() {
   for (TEXTBOX t : textboxes) {
      if (t.KEYPRESSED(key, (int)keyCode)) {
       //  Submit();
      }
   }
}

double getFloat(String s){
  s=s+'$' ;
  int position=0 ;
  double val=0 ;
  while(isNum(s.charAt(position))){
    val=10*val+s.charAt(position)-'0' ;
    position=position+1 ;
    }
  if(s.charAt(position)=='.'){
    position=position+1 ;
    double q=0.1 ;
    while(isNum(s.charAt(position))){
      val=val+q*(s.charAt(position)-'0') ;
      position=position+1 ;
      q=q/10 ;
      }
    }
  if(s.charAt(position)=='M'){
    position=position+1 ;
    val=val*1e6 ;
    }
  if(s.charAt(position)=='k'){
    position=position+1 ;
    val=val*1e3 ;
    }
        
    
  return val ;
  }